{% extends "customers/base.html" %}
{% load i18n %}
{% load staticfiles %}
{% load active_tag %}
{% load md2 %}

{% block title %}Reportes{% endblock %}

{% block pagelevelcss %}
<link href="{% static 'theme/plugins/c3/c3.min.css' %}" rel="stylesheet" type="text/css">

      <style>
	table thead tr{
	display:block;
	
	}

	table th,table td{
	width:100px;//fixed width
	}


	table  tbody{
	display:block;
	height:300px;
	overflow:auto;//set tbody to auto
	
	}
      </style>

{% endblock %}

{% block page %}
<!-- begin breadcrumb -->
<ol class="breadcrumb float-xl-right">
		<li class="breadcrumb-item"><a href="{% url 'home' %}">Home</a></li>
		<li class="breadcrumb-item active">Reporte de estados en nodo</li>
	  </ol>
	  <!-- end breadcrumb -->
	
	<!-- begin page-header -->
	<h1 class="page-header">Cambio de estados por nodo <small>Ver cambios de estado por nodo</small></h1>
	<!-- end page-header -->



<!-- begin row -->
<div class="row">
		<!-- begin col-12 -->
		<div class="col-xl-12 ui-sortable">
			<!-- begin panel -->
			<div class="panel panel-inverse" data-sortable-id="ui-general-1">
				<!-- begin panel-heading -->
				<div class="panel-heading ui-sortable-handle">
					<h4 class="panel-title">Cambios</h4>
					<div class="panel-heading-btn">
						<a href="javascript:;" class="btn btn-xs btn-icon btn-circle btn-default" data-click="panel-expand"><i class="fa fa-expand"></i></a>
						<a href="javascript:;" class="btn btn-xs btn-icon btn-circle btn-success" data-click="panel-reload"><i class="fa fa-redo"></i></a>
						<a href="javascript:;" class="btn btn-xs btn-icon btn-circle btn-warning" data-click="panel-collapse"><i class="fa fa-minus"></i></a>
						<a href="javascript:;" class="btn btn-xs btn-icon btn-circle btn-danger" data-click="panel-remove"><i class="fa fa-times"></i></a>
					</div>
				</div>
				<!-- end panel-heading -->
				<!-- begin panel-body -->
				<div class="panel-body">
    				<div id="node-app">
						<div class="row mb-3">
							<div class="col-sm-12 col-md-6">
								<h5 class="text-muted">Filtros:</h5>
								<p>
								<label>Desde:</label>
								<input type="date" v-model="initiald">
								</p>
								
								<p>
								<label>Hasta:</label>
								<input type="date" v-model="finald">
								</p>
							  </div>
							</div>
							  
						<div class="row mb-3">
							<div class="col-sm-12 col-md-12">
								{% verbatim %}
								<h4 style="display: inline;">Estados por nodo</h4>
								<h5 class="text-muted ml-1" style="display: inline;">{{ message }}</h5>
								<table class="table table-bordered mt-2">
								<thead>
								<tr>
								{% endverbatim %}
								<th>Nodo(dirección)</th>
								{% for status in statuses %}
								<th>{{ status.name }}</th>
								{% endfor %}
								{% verbatim %}
								</tr>
								</thead>
								<tbody>
								<tr v-for="(item, key, index) in snapshots">
								<td>{{ key }}</td>
								{% endverbatim %}
								{% for sx in statuses %}
									<td align="right">
								{% verbatim %}{{{% endverbatim %}
								item.status_data.status_code_{{ sx.code }}
								{% verbatim %}
								| thousand
								{% endverbatim %}
								{% verbatim %}
								}}
								{% endverbatim %}</td>
								{% endfor %}
								{% verbatim %}
								</tr>
								</tbody>
								</table>
								{% endverbatim %}
							</div>
						</div>
					</div> <!-- node-app -->
					<!-- end panel-body -->
				</div>
				<!-- end panel -->
			</div>
		</div>
		<!-- end column -->
	</div>
	<!-- end row -->

<!-- begin scroll to top btn -->
<a href="javascript:;" class="btn btn-icon btn-circle btn-success btn-scroll-to-top fade" data-click="scroll-top"><i class="fa fa-angle-up"></i></a>
<!-- end scroll to top btn -->
{% endblock %}
  

{% block pageleveljs %}
<script type="text/javascript">
    //active menu
    document.getElementById("reports_menu").classList.add("active");
    //active submenu item
    document.getElementById("nodereport_item").classList.add("active");
</script>
<script src="{% static 'js/vue' %}"></script>
    <script src="{% static 'js/vue-resource' %}"></script>
    <script src="{% static 'js/vue-select' %}"></script>
    <script src="{% static 'js/lodash.min.js' %}"></script>

<script>
    get = function(obj, key) {
	return key.split(".").reduce(function(o, x) {
	    return (typeof o == "undefined" || o === null) ? o : o[x];
	}, obj);
    }

  Vue.component('v-select', VueSelect.VueSelect);

  // Register a global custom directive called v-focus
  Vue.directive('focus', {
  // When the bound element is inserted into the DOM...
  inserted: function (el) {
  // Focus the element
  el.focus()
    
  }
  
  })

  var node_app = new Vue({
      el: '#node-app',
      data: {
          message: null,
	  initiald: "{{ first_of_month }}",
	  finald: "{{ last_of_month }}",
	  snapshots: {},
      },
      filters: {
	  clp: function(value) {
	      return '$'+value;
	  },
	  thousand: function(value){
	      if (value) {
		  return value.toLocaleString('es-CL');
	      } else {
		  return 0;
	      }
	  }
      },
      watch: {
	  initiald: function(newInitialD) {
	      if (newInitialD) {
		  this.message = 'Refrescando datos...';
	      }
	      this.refreshData();
	  },
	  finald: function(newFinalD) {
	      if (newFinalD) {
		  this.message = 'Refrescando datos...';
	      }
	      this.refreshData();
	  },
      },
      mounted: function () {
	  this.refreshData();
      },
      methods: {
	  refreshData: _.debounce(
	      function() {
		  this.$http.get('/customers/node-table-ajax/'+'?'+'initiald='+this.initiald+'&finald='+this.finald).then(response => {
		      var unordered = response.body.snapshot_data;
		      var ordered = {};
		      Object.keys(unordered).sort().forEach(function(key) {
			  ordered[key] = unordered[key];
		      });
		      this.snapshots = ordered;
		      this.message = null;
		  });
	      },
	      300
	  )
      }
  })

</script>

{% endblock %}
